<?php
/*
Plugin Name: deDebilizator
Plugin URI: http://blog.portal.kharkov.ua/
Description: Усекновение слов в комментариях
Author: Yuri 'Bela' Belotitski
Version: 1.1 @ 21.03.2010
Author URI: http://www.portal.khakrov.ua/
*/

add_filter('preprocess_comment', 'dedebilizator');
function dedebilizator($commentdata) {
	$words = explode(' ',$commentdata['comment_content']);
	$commentdata['comment_content'] = '';
	foreach ($words AS $word) {
		if (mb_strlen($word,'UTF-8')>20)
			$commentdata['comment_content'] .= ' ' . utf8_wordwrap($word,20,'&shy;');
		else
			$commentdata['comment_content'] .= ' ' . $word;
	}
	return $commentdata;
}

function utf8_wordwrap($str,$len,$what){
# usage: utf8_wordwrap("text",3,"<br>");
# by tjomi4`, thanks to SiMM.
# www.yeap.lv
	$from=0;
	$str_length = preg_match_all('/[\x00-\x7F\xC0-\xFD]/', $str, $var_empty);
	$while_what = $str_length / $len;
	while($i <= round($while_what)){
		$string = preg_replace('#^(?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'.$from.'}'.
                       '((?:[\x00-\x7F]|[\xC0-\xFF][\x80-\xBF]+){0,'.$len.'}).*#s',
                       '$1',$str);
		$total .= $string.$what;
		$from = $from+$len;
		$i++;
	}
	return $total;
}
?>